(******************************************************************************
 ******************************************************************************
 ***                                                                        ***
 ***  NtStatus - shows the NTSTATUS codes in text form                      ***
 ***  Version [1.01]                                {Last mod 2003-09-20}   ***
 ***                                                                        ***
 ******************************************************************************
 ******************************************************************************

                                 _\\|//_
                                (` * * ')
 ______________________________ooO_(_)_Ooo_____________________________________
 ******************************************************************************
 ******************************************************************************
 ***                                                                        ***
 ***                Copyright (c) 1995 - 2003 by -=Assarbad=-               ***
 ***                                                                        ***
 ***   CONTACT TO THE AUTHOR(S):                                            ***
 ***    ____________________________________                                ***
 ***   |                                    |                               ***
 ***   | -=Assarbad=- aka Oliver            |                               ***
 ***   |____________________________________|                               ***
 ***   |                                    |                               ***
 ***   | Assarbad@gmx.info|.net|.com|.de    |                               ***
 ***   | ICQ: 281645                        |                               ***
 ***   | AIM: nixlosheute                   |                               ***
 ***   |      nixahnungnicht                |                               ***
 ***   | MSN: Assarbad@ePost.de             |                               ***
 ***   | YIM: sherlock_holmes_and_dr_watson |                               ***
 ***   |____________________________________|                               ***
 ***             ___                                                        ***
 ***            /   |                     ||              ||                ***
 ***           / _  |   ________ ___  ____||__    ___   __||                ***
 ***          / /_\ |  / __/ __//   |/  _/|   \  /   | /   |                ***
 ***         / ___  |__\\__\\  / /\ || |  | /\ \/ /\ |/ /\ | DOT NET        ***
 ***        /_/   \_/___/___/ /_____\|_|  |____/_____\\__/\|                ***
 ***       ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~        ***
 ***              [http://assarbad.net | http://assarbad.org]               ***
 ***                                                                        ***
 ***   Notes:                                                               ***
 ***   - my first name is Oliver, you may well use this in your e-mails     ***
 ***   - for questions and/or proposals drop me a mail or instant message   ***
 ***                                                                        ***
 ***~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~***
 ***              May the source be with you, stranger ... ;)               ***
 ***    Snizhok, eto ne tolko fruktovij kefir, snizhok, eto stil zhizn.     ***
 ***                     Vsem Privet iz Germanij                            ***
 ***                                                                        ***
 *** Greets from -=Assarbad=- fly to YOU =)                                 ***
 *** Special greets fly 2 Nico, Casper, SA, Pizza, Navarion, Eugen, Zhenja, ***
 *** Xandros, Melkij, Strelok etc pp.                                       ***
 ***                                                                        ***
 *** Thanks to:                                                             ***
 *** W.A. Mozart, Vivaldi, Beethoven, Poeta Magica, Kurtzweyl, Manowar,     ***
 *** Blind Guardian, Weltenbrand, In Extremo, Wolfsheim, Carl Orff, Zemfira ***
 *** ... most of my work was done with their music in the background ;)     ***
 ***                                                                        ***
 ******************************************************************************
 ******************************************************************************

 LEGAL STUFF:
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

 Copyright (c) 1995-2003, -=Assarbad=- ["copyright holder(s)"]
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.
 3. The name(s) of the copyright holder(s) may not be used to endorse or
    promote products derived from this software without specific prior written
    permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                             .oooO     Oooo.
 ____________________________(   )_____(   )___________________________________
                              \ (       ) /
                               \_)     (_/

 ******************************************************************************)
program NtStatus;
uses
  Windows,
  Messages,
  NTSTATUS_strings in '.\Include\NTSTATUS_strings.pas';

{$R main.res}
const
  IDD_DIALOG1 = 101;
  IDC_EDIT1 = 1000;
  IDC_EDIT2 = 1001;
  IDC_EDIT3 = 1003;

var
  fix8: HFONT;

function MAKELANGID(p, s: word): Integer;
begin
  result := (s shl 10) or p
end;

function GetNtStatusMessage(status: NTSTATUS_strings.NTSTATUS): string;
var
  lpMessageBuffer: PChar;
  hModule: THandle;
begin
  hModule := LoadLibrary('NTDLL.DLL');
  FormatMessage(
    FORMAT_MESSAGE_ALLOCATE_BUFFER or FORMAT_MESSAGE_FROM_SYSTEM or FORMAT_MESSAGE_FROM_HMODULE,
    Pointer(hModule),
    status,
    MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
    @lpMessageBuffer,
    0,
    nil);
   // Now display the string.
  SetString(result, lpMessageBuffer, lstrlen(lpMessageBuffer));
   // Free the buffer allocated by the system.
  LocalFree(THandle(lpMessageBuffer));
  FreeLibrary(hModule);
end;

function Main_EnumChildSetFonts(hwnd: HWND; lParam: LPARAM): BOOL; stdcall;
begin
  result := True;
// According to the current control ...
  case GetDlgCtrlID(hwnd) of
    IDC_EDIT1:
      begin
// ... set the font given by lParam
        SendMessage(hwnd, WM_SETFONT, lParam, ord(TRUE));
        SendMessage(hwnd, EM_SETLIMITTEXT, 8, 0);
      end;
  end;
end;

function Main_DlgFunc(hWnd: HWND; uMsg: UINT; wparam: WPARAM; lparam: LPARAM): BOOL; stdcall;
// MAIN DIALOG
var
  buffer: array[0..$FF] of Char;
  value: string;
  status: NTSTATUS_strings.NTSTATUS;
  code: Integer;
begin
  Result := True;
  case uMsg of
    WM_INITDIALOG:
      begin
// Get a 8 Point fixed font
        fix8 := CreateFont(-MulDiv(8, GetDeviceCaps(GetWindowDC(hwnd), LOGPIXELSY), 72), 0, 0, 0, FW_NORMAL, 0, 0, 0, ANSI_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY, FIXED_PITCH or FF_MODERN, 'Courier New');
// And set it
        EnumChildWindows(hwnd, @Main_EnumChildSetFonts, fix8);
      end;
    WM_CLOSE:
// Close the dialog
      EndDialog(hWnd, 0);
    WM_COMMAND:
      case HiWord(WParam) of
// A button was clicked
        BN_CLICKED:
          case LOWORD(wParam) of
// OK Buttin is there to generate one password
            IDOK:
              begin
                ZeroMemory(@buffer, sizeof(buffer));
                GetDlgItemText(hwnd, IDC_EDIT1, @buffer, sizeof(buffer) - 1);
                SetString(value, PChar(@buffer), lstrlen(@buffer));
                value := '$' + value;
                val(value, status, code);
                if code = 0 then
                begin
                  value := GetNtStatusText(status) + #13#10 + GetNtStatusMessage(status);
                  SetDlgItemText(hwnd, IDC_EDIT2, @value[1]);
                end
                else
                  Windows.Beep(200, 200);
              end;
// Set the text upon click onto one of the radio buttons
            IDCANCEL:
              begin
                SendMessage(hwnd, WM_CLOSE, 0, 0);
              end;
          end;
      end;
  else
// Handle all other window messages
    Result := False;
  end;
end;

begin
// Create and show main dialog
  DialogBoxParam(hInstance, MAKEINTRESOURCE(IDD_DIALOG1), 0, @Main_DlgFunc, 0);
end.

